        use omp_lib
        implicit none
        integer :: i,j,c
        integer,parameter :: reps=100000,n=1024,m=100
        real (kind=8), allocatable :: x(:,:)
        real (kind=8) :: time1
 
 
! Initialise vector data
        allocate (x(n,m)) 
        do i=1,m 
           do j=1,n
              x(j,i) =  3.142
           end do
        end do
 
! sum operation
        print *, "Offset    Nanosecs/ref"
 
        do c = 1,64

           time1=omp_get_wtime()
           do i=1,reps
              call sumsubfs (x,n,c,m)
              if (x(0,0) .lt. 0.0) print *, "Help!"  
           end do 
           time1=omp_get_wtime()-time1
        print *, c-20," ",(1000000000.*time1)/real(m*reps)
        end do
 
        end
 
 
 
        subroutine sumsubfs (a,n,offset,m)
        use omp_lib
 
! .. Scalar arguments 
       integer :: n,offset,m
 
! .. Array arguments
       real (kind=8) ::  a(n,m)
 
! .. Local scalars
       integer :: i,id

!$omp parallel  private(i,id) 
 
        id  = omp_get_thread_num()

        if (id .eq. 0) then

           do i=1,m
              a(20,i)=a(20,i)+3.142 
           enddo 

        elseif (id .eq. 1) then 

           do i=1,m
              a(offset,i)=a(offset,i)+3.142
           end do 

        end if 

!$omp end parallel 

        return
        end

